﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Documents.Excel;

namespace ArrayFormula
{
    class Program
    {
        static void Main(string[] args)
        {
            // Create the workbook and a worksheet.
            Workbook wb = new Workbook(WorkbookFormat.Excel2007);
            Worksheet ws = wb.Worksheets.Add("Sheet 1");

            // Put some sample data in the rows.
            ws.Rows[0].Cells[0].Value = 1;    ws.Rows[0].Cells[1].Value = 1;
            ws.Rows[1].Cells[0].Value = 2;    ws.Rows[1].Cells[1].Value = 2;
            ws.Rows[2].Cells[0].Value = 3;    ws.Rows[2].Cells[1].Value = 3;
            ws.Rows[3].Cells[0].Value = 4;    ws.Rows[3].Cells[1].Value = 4;
            ws.Rows[4].Cells[0].Value = 5;    ws.Rows[4].Cells[1].Value = 5;
            ws.Rows[5].Cells[0].Value = 6;    ws.Rows[5].Cells[1].Value = 6;
            ws.Rows[6].Cells[0].Value = 7;    ws.Rows[6].Cells[1].Value = 7;
            ws.Rows[7].Cells[0].Value = 8;    ws.Rows[7].Cells[1].Value = 8;
            ws.Rows[8].Cells[0].Value = 9;    ws.Rows[8].Cells[1].Value = 9;
            ws.Rows[9].Cells[0].Value = 10;   ws.Rows[9].Cells[1].Value = 10;

            Infragistics.Documents.Excel.ArrayFormula f = Infragistics.Documents.Excel.ArrayFormula.Parse("=SUM((B1:B10)*(A1:A10))", CellReferenceMode.A1);
            WorksheetRegion region = new WorksheetRegion(ws, 0, 2, 0, 2);
            f.ApplyTo(region);

            WorksheetRegion region2 = new WorksheetRegion(ws, 1, 2, 1, 2);
            region2.ApplyArrayFormula("=SUM((B1:B10)*(A1:A10))");

            wb.Save("test.xlsx");
        }
    }
}
